// TsEITRead.cpp : R\[ AvP[ṼGg |Cg`܂B
//
#include "stdafx.h"
#include "tsdata.h"
#include "ts_sidef.h"
#include "ts_packet.h"
#include "wingetopt.h"

//TODO: -C (range)	yz(output)eLXgt@Cł͂ȂATSt@C̎w肵͈͂؂̂ɂȂ܂
//			(range)(start_packet_idx):(end_packet_idx)
using namespace std;

#define			STR_STL_LOCALE	"japanese"					// STLlocaleɓn
#define			MAX_PID_NUM		8192

//#define _TEST_USE_FS_

// main̕Ԃl
enum
{
	ERR_PARAM = 1,
	ERR_INPUTFILE,
	ERR_OUTPUTFILE,
	ERR_NOTOT,
	ERR_NOPAT,
	ERR_NOSDT,
};

// PID̃ZNVobt@
// mapgĂߖʂ͒mĂ̂ŔzŎ
static CSectionBuf	*ev_pSectionBuf[MAX_PID_NUM];

static UINT64		ev_BefSectionFilePos[MAX_PID_NUM];		// ȑÕt@Cʒu(擪:1)BpacketP(bytePʂł͂Ȃ)

static UINT64		ev_cur_filepos;							// ݂̃t@Cʒu(擪:1)BpacketP(bytePʂł͂Ȃ)

// IvVp[^
enum E_READ_SIZE{RS_SIZE,RS_RATIO,RS_SEC,};
static bool			ev_opt_is_out_patpmt = false;			// PAT/PMTo͂H
static bool			ev_opt_is_all_out = false;				// ST[rX/Cxgo͂H
static bool			ev_opt_is_out_extevt = false;			// g`CxgLqqo͂H
static int			ev_opt_offset_read = 0;					// ǂݍ݃ItZbg
static bool			ev_opt_offset_read_is_ratio = false;
static int			ev_opt_max_read_size = 0;				// őǂݍ݃TCY(*188*1000byte)
static E_READ_SIZE	ev_opt_max_read_type = RS_SIZE;
static int			ev_opt_offset_beg = 0;					// JnItZbgb
static int			ev_opt_offset_end = 0;					// IItZbgb
static bool			ev_opt_read_eit_sch = false;			// EIT(XPW[)ǂݍށH
static bool			ev_opt_verbose = false;					// ڍ׏o̓[h
static bool			ev_opt_no_progress = false;				// i\oȂ
static bool			ev_opt_outtime_offset = false;			// 
static int			ev_opt_evt_output_type = 0;
static const TCHAR	*ev_opt_input_fname = NULL;				// ݏĂTSt@C(fobOOp)
static const TCHAR	*ev_opt_output_fname = NULL;			// o̓t@C
static const TCHAR	*ev_opt_dbgout_fname = NULL;
static const TCHAR	*ev_opt_dbglog_fname = NULL;

// 
static bool			ev_dbglog_flg = false;					// fobOOtOB܂1o͂ĂȂFALSE
static tostream		*ev_ps_dbglog = NULL;					// fobOOo͗pXg[


// TSt@C̔ԑgobt@Op
static vector<CPAT>		ev_pats;
static vector<CEIT*>	ev_peits;		// 񎝂\AinsertƂ̎sRXgoJɂȂȂŁA|C^Ŏ
static vector<CSDT*>	ev_psdts;		// 
static vector<CPMT>		ev_pmts;
static vector<CTOT>		ev_tots;		// 2ێ

// eit1 < eit2̎ trueԂ
static bool _compare_eit(const CEIT *eit1, const CEIT *eit2)
{
	const CServiceInfo *p = eit2;
	return eit1->CompareTo( p, true ) > 0;
}

// pmt1 < pmt2̎ trueԂ
static bool _compare_pmt(const CPMT &pmt1, const CPMT &pmt2)
{
	const CServiceInfo *p = &pmt2;
	return pmt1.CompareTo( p, true ) > 0;
}

// sdt1 < sdt2̎ trueԂ
static bool _compare_sdt(const CSDT *sdt1, const CSDT *sdt2)
{
	const CServiceInfo *p = sdt2;
	return sdt1->CompareTo( p, true ) > 0;
}

// ԂlFȉ̂ꂩBCRCG[Ƃꍇ͌㑱pPbg͂
enum eSECTION_RET
{
	SEC_NG_NEXT = 0,			// NGBpPbgv
	SEC_OK_END,					// OKBZNVf[^I
	SEC_OK_RETRY,				// OKB
};
static eSECTION_RET _dump_section_data(const CPacket &packet, CSectionBuf *p_sec_buf, bool is_read_eit_sch)
{
	eSECTION_RET	ret = SEC_NG_NEXT;
	size_t			sec_len = 0;
	int				dbg_flg = 0;				// fobOptO
	switch ( packet.header.pid )
	{
	case PID_PAT:
		// ȈՓIɖ
		if ( ev_pats.size() == 0 
			|| ev_pats.back().version != CServiceInfo::GetVersion(p_sec_buf->GetData()) 
			|| ev_pats.back().id != CServiceInfo::GetID(p_sec_buf->GetData())
			)
		{
			CPAT	pat;
			if ( pat.SetData( p_sec_buf->GetData() ) )
			{
				ev_pats.push_back( pat );
				sec_len = pat.GetBodySize();
				ret = SEC_OK_END;
			}
		}
		else
			return SEC_OK_END;		// df[^Ȃ̂ŏς݂ɂƂ
		break;
	case PID_EIT_0:
	case PID_EIT_1:
	case PID_EIT_2:
		{
			//CEIT	eit;
			CEIT	*peit = new CEIT();
			bool	is_ignore;
			if ( peit->SetData( p_sec_buf->GetData(), !is_read_eit_sch, &is_ignore ) )
			{
//#ifdef _DEBUG
#if 0
				if ( peit->transport_stream_id == 16625 && peit->id == 101 && peit->table_id == 0x58 )
				{
					DBG_LOG_WARN( _T("version:%2d section:%3d segment_last:%3d last_section:%3d length:%4d\n"), 
						peit->version, peit->section, peit->segment_last_section_number, peit->last_section, peit->length );
				//	_CrtDbgBreak();
				}
#endif
				sec_len = peit->GetBodySize(); 
				if ( !is_ignore )
				{
					vector<CEIT*>::iterator pos = ev_peits.end();
					if ( ev_peits.size() > 0 )
						pos = lower_bound( ev_peits.begin(), ev_peits.end(), peit, _compare_eit );
					int idx = pos - ev_peits.begin();
					if ( pos == ev_peits.end() )
					{
						ev_peits.push_back( peit );
						dbg_flg = 1;
					}
					else if ( (*pos)->CompareTo( peit, true ) == 0 )
					{
						(*pos)->AddData( *peit );
						// Cxge[ûȂ̂ɕtĂEITe[uɂ͓Ȃ
						if ( (*pos)->IsFullProcSection() && (*pos)->event_tbl.size() == 0 )
						{
							delete ev_peits[idx];
							ev_peits.erase( pos );
						}
						dbg_flg = 2;
						delete peit;
					}
					else
					{
						ev_peits.insert( pos, peit );
						dbg_flg = 3;
					}
				}
				else
					delete peit;
				ret = SEC_OK_END;
			}
			else
			{
				ret = SEC_NG_NEXT;
				delete peit;
			}
		}
		break;
	case PID_TOT:
		{
			CTOT	tot;
			if ( tot.SetData( p_sec_buf->GetData() ) )
			{
				// 擪̑}܂͒ǉ
				if ( ev_tots.size() == 0 )
					ev_tots.push_back( tot );
				else if ( ev_tots.size() > 1 && tot.jst_time < ev_tots[0].jst_time )
				{
					ev_tots.erase( ev_tots.begin() );
					ev_tots.insert( ev_tots.begin(), tot );
					_ASSERT( FALSE );			// nɕł͂ȂŁAꉞx
				}

				// ̒ǉ
				if		( ev_tots.size() < 2 )
				{
					ev_tots.push_back( tot );
				}
				else if ( tot.jst_time > ev_tots[1].jst_time )
				{	
					ev_tots.pop_back();
					ev_tots.push_back( tot );
				}
				else
					_ASSERT( FALSE );

				sec_len = tot.GetBodySize(); 
				_ASSERT( ev_tots.size() <= 2 );
				
				ret = SEC_OK_END;
			}
		}
		break;
	case PID_SIT:
		//
		break;
	case PID_SDT:
		{
			CSDT	*psdt = new CSDT();
			if ( psdt->SetData( p_sec_buf->GetData() ) )
			{
				vector<CSDT*>::iterator pos = ev_psdts.end();
				sec_len = psdt->GetBodySize(); 
				if ( ev_psdts.size() > 0 )
					pos = lower_bound( ev_psdts.begin(), ev_psdts.end(), psdt, _compare_sdt );
				if ( pos == ev_psdts.end() )
				{
					ev_psdts.push_back( psdt );
				}
				else if ( (*pos)->CompareTo( psdt, true ) == 0 )
				{
					(*pos)->AddData( *psdt );
					delete psdt;
				}
				else
				{
					ev_psdts.insert( pos, psdt );
				}
				ret = SEC_OK_END;

			}
			else
			{
				ret = SEC_NG_NEXT;
				delete psdt;
			}
		}
		break;
	default:
		if ( ev_opt_is_out_patpmt )
		{
			CPMT	pmt;
			pmt.m_self_pid = packet.header.pid;
			pmt.m_file_pos = ev_cur_filepos;
			if ( pmt.SetData( p_sec_buf->GetData() ) )
			{
				vector<CPMT>::iterator pos = ev_pmts.end();
				if ( ev_pmts.size() > 0 )
					pos = lower_bound( ev_pmts.begin(), ev_pmts.end(), pmt, _compare_pmt );
				if ( pos == ev_pmts.end() )
					ev_pmts.push_back( pmt );
				else if ( pos->CompareTo( &pmt, true ) == 0 )
				{
					pos->AddData( pmt );
				}
				else
					ev_pmts.insert( pos, pmt );
				sec_len = pmt.GetBodySize(); 
				ret = SEC_OK_END;
			}
			else
				ret = SEC_NG_NEXT;
		}
		break;
	}
	if ( sec_len && p_sec_buf->GetData().size() > sec_len + 4 )
	{
		int last_pt = sec_len + 4;
		VECT_UINT8::const_iterator it = p_sec_buf->GetData().begin() + last_pt;
		if ( *it != 0xFF )
		{
			// ꍇB
			VECT_UINT8	dmy_buf;
			dmy_buf.push_back( 0 );			// |C^[tB[h擪ɑ}
			std::copy( it, p_sec_buf->GetData().end(), back_inserter(dmy_buf) );
			p_sec_buf->ClearData();
			p_sec_buf->AddData( packet.header.index, &dmy_buf[0], &dmy_buf[0] + dmy_buf.size() );
			return SEC_OK_RETRY;
		}
		else
			int iii = 0;
	}
	return ret;
}

// Cxg啪ޕ擾
static const TCHAR*	_get_genre_lvl1_str(int genre)
{
	static const TCHAR *c_lvl1_str[] = {
		_T("j[X^"),			// 0x0  
		_T("X|[c"),					// 0x1  
		_T("^ChV["),		// 0x2  
		_T("h}"),					// 0x3  
		_T("y"),						// 0x4  
		_T("oGeB"),				// 0x5  
		_T("f"),						// 0x6  
		_T("Aj^B"),				// 0x7  
		_T("hL^[^{"),	// 0x8  
		_T("^"),				// 0x9  
		_T("^"),				// 0xA  
		_T(""),						// 0xB  
		_T("\"),						// 0xC  
		_T("\"),						// 0xD  
		_T("g"),						// 0xE  
		_T("̑ "),					// 0xF  

		_T("WwȂ"),				
	};
	_ASSERT( sizeof(c_lvl1_str) / sizeof(c_lvl1_str[0]) == 0x11 );
	if ( genre < 0 )
		return c_lvl1_str[0x10];
	else
		return c_lvl1_str[(genre>>4)&0xF];
}

// Cxgޕ擾
static const TCHAR*	_get_genre_lvl2_str(int genre)
{
	static const TCHAR *c_lvl2_str[] = {
		_T("莞E"),					// 0x0 0x0  
		_T("VC"),							// 0x0 0x1  
		_T("WEhLg"),			// 0x0 0x2  
		_T("E"),					// 0x0 0x3  
		_T("oρEs"),					// 0x0  0x4  
		_T("COE"),					// 0x0  0x5  
		_T(""),							// 0x0  0x6  
		_T("_Ek"),					// 0x0  0x7  
		_T("񓹓"),						// 0x0  0x8  
		_T("[JEn"),				// 0x0  0x9  
		_T(""),							// 0x0  0xA  
		_T(""),								// 0x0  0xB   
		_T(""),								// 0x0  0xC   
		_T(""),								// 0x0  0xD   
		_T(""),								// 0x0  0xE   
		_T("̑"),						// 0x0  0xF  

		_T("X|[cj[X"),				// 0x1 0x0  
		_T("싅"),							// 0x1 0x1  
		_T("TbJ["),						// 0x1 0x2  
		_T("St"),						// 0x1 0x3  
		_T("̑̋Z"),					// 0x1 0x4  
		_T("oEiZ"),					// 0x1 0x5  
		_T("IsbNEۑ"),		// 0x1 0x6  
		_T("}\EEj"),			// 0x1 0x7  
		_T("[^[X|[c"),				// 0x1 0x8  
		_T("}EEB^[X|[c"),	// 0x1 0x9  
		_T("nEcZ"),				// 0x1 0xA  
		_T(""),								// 0x1 0xB   
		_T(""),								// 0x1 0xC   
		_T(""),								// 0x1 0xD   
		_T(""),								// 0x1 0xE   
		_T("̑"),						// 0x1 0xF  

		_T("|\EChV["),			// 0x2 0x0  
		_T("t@bV"),					// 0x2 0x1  
		_T("炵EZ܂"),				// 0x2  0x2  
		_T("NE"),					// 0x2  0x3  
		_T("VbsOEʔ"),			// 0x2  0x4  
		_T("OE"),					// 0x2  0x5  
		_T("Cxg"),						// 0x2  0x6  
		_T("ԑgЉEm点"),			// 0x2  0x7  
		_T(""),								// 0x2 0x8   
		_T(""),								// 0x2 0x9   
		_T(""),								// 0x2 0xA   
		_T(""),								// 0x2 0xB   
		_T(""),								// 0x2 0xC   
		_T(""),								// 0x2 0xD   
		_T(""),								// 0x2 0xE   
		_T("̑"),						// 0x2 0xF  

		_T("h}"),					// 0x3  0x0  
		_T("COh}"),					// 0x3  0x1  
		_T("㌀"),						// 0x3  0x2  
		_T(""),								// 0x3  0x3   
		_T(""),								// 0x3  0x4   
		_T(""),								// 0x3  0x5   
		_T(""),								// 0x3  0x6   
		_T(""),								// 0x3  0x7   
		_T(""),								// 0x3  0x8   
		_T(""),								// 0x3  0x9   
		_T(""),								// 0x3  0xA   
		_T(""),								// 0x3  0xB   
		_T(""),								// 0x3  0xC   
		_T(""),								// 0x3  0xD   
		_T(""),								// 0x3  0xE   
		_T("̑"),						// 0x3  0xF  

		_T("bNE|bvX"),			// 0x4 0x0  
		_T("CObNE|bvX"),			// 0x4 0x1  
		_T("NVbNEIy"),			// 0x4 0x2  
		_T("WYEt[W"),			// 0x4 0x3  
		_T("̗wȁE"),					// 0x4 0x4  
		_T("CuERT[g"),			// 0x4 0x5  
		_T("LOENGXg"),		// 0x4 0x6  
		_T("JIPÊǎ"),			// 0x4 0x7  
		_T("wEMy"),					// 0x4 0x8  
		_T("wELbY"),					// 0x4 0x9  
		_T("yE[h~[WbN"),	// 0x4 0xA  
		_T(""),									// 0x4 0xB   
		_T(""),									// 0x4 0xC   
		_T(""),									// 0x4 0xD   
		_T(""),									// 0x4 0xE   
		_T("̑"),							// 0x4 0xF  

		_T("NCY"),							// 0x5  0x0  
		_T("Q["),							// 0x5  0x1  
		_T("g[NoGeB"),					// 0x5  0x2  
		_T("΂ERfB"),					// 0x5  0x3  
		_T("yoGeB"),					// 0x5  0x4  
		_T("oGeB"),						// 0x5  0x5  
		_T("oGeB"),					// 0x5  0x6  
		_T(""),									// 0x5  0x7   
		_T(""),									// 0x5  0x8   
		_T(""),									// 0x5  0x9   
		_T(""),									// 0x5  0xA   
		_T(""),									// 0x5  0xB   
		_T(""),									// 0x5  0xC   
		_T(""),									// 0x5  0xD   
		_T(""),									// 0x5  0xE   
		_T("̑"),							// 0x5  0xF  

		_T("m"),								// 0x6 0x0  
		_T("M"),								// 0x6 0x1  
		_T("Aj"),							// 0x6 0x2  
		_T(""),									// 0x6 0x3   
		_T(""),									// 0x6 0x4   
		_T(""),									// 0x6 0x5   
		_T(""),									// 0x6 0x6   
		_T(""),									// 0x6 0x7   
		_T(""),									// 0x6 0x8   
		_T(""),									// 0x6 0x9   
		_T(""),									// 0x6 0xA   
		_T(""),									// 0x6 0xB   
		_T(""),									// 0x6 0xC   
		_T(""),									// 0x6 0xD   
		_T(""),									// 0x6 0xE   
		_T("̑"),							// 0x6 0xF  

		_T("Aj"),		// 0x7  0x0  
		_T("COAj"),		// 0x7  0x1  
		_T("B"),		// 0x7  0x2  
		_T(""),		// 0x7  0x3   
		_T(""),		// 0x7  0x4   
		_T(""),		// 0x7  0x5   
		_T(""),		// 0x7  0x6   
		_T(""),		// 0x7  0x7   
		_T(""),		// 0x7  0x8   
		_T(""),		// 0x7  0x9   
		_T(""),		// 0x7  0xA   
		_T(""),		// 0x7  0xB   
		_T(""),		// 0x7  0xC   
		_T(""),		// 0x7  0xD   
		_T(""),		// 0x7  0xE   
		_T("̑"),		// 0x7  0xF  

		_T("ЉE"),		// 0x8 0x0  
		_T("jEIs"),		// 0x8 0x1  
		_T("REE"),		// 0x8 0x2  
		_T("FEȊwEw"),		// 0x8 0x3  
		_T("J`[E`"),		// 0x8 0x4  
		_T("wE|"),		// 0x8 0x5  
		_T("X|[c"),		// 0x8 0x6  
		_T("hL^[S"),		// 0x8 0x7  
		_T("C^r[E_"),		// 0x8 0x8  
		_T(""),		// 0x8 0x9   
		_T(""),		// 0x8 0xA   
		_T(""),		// 0x8 0xB   
		_T(""),		// 0x8 0xC   
		_T(""),		// 0x8 0xD   
		_T(""),		// 0x8 0xE   
		_T("̑"),		// 0x8 0xF  

		_T("㌀EV"),		// 0x9  0x0  
		_T("~[WJ"),		// 0x9  0x1  
		_T("_XEoG"),		// 0x9  0x2  
		_T("E|"),		// 0x9  0x3  
		_T("̕EÓT"),		// 0x9  0x4  
		_T(""),		// 0x9  0x5   
		_T(""),		// 0x9  0x6   
		_T(""),		// 0x9  0x7   
		_T(""),		// 0x9  0x8   
		_T(""),		// 0x9  0x9   
		_T(""),		// 0x9  0xA   
		_T(""),		// 0x9  0xB   
		_T(""),		// 0x9  0xC   
		_T(""),		// 0x9  0xD   
		_T(""),		// 0x9  0xE   
		_T("̑"),		// 0x9  0xF  

		_T("EނEAEghA"),		// 0xA 0x0  
		_T("|EybgE|"),		// 0xA 0x1  
		_T("yEpEH|"),		// 0xA 0x2  
		_T("͌E"),		// 0xA 0x3  
		_T("Ep`R"),		// 0xA 0x4  
		_T("ԁEI[goC"),		// 0xA 0x5  
		_T("Rs[^EsuQ["),		// 0xA 0x6  
		_T("bEw"),		// 0xA 0x7  
		_T("cEw"),		// 0xA 0x8  
		_T("wEZ"),		// 0xA 0x9  
		_T("wE"),		// 0xA 0xA  
		_T("UEi"),		// 0xA 0xB  
		_T(""),		// 0xA 0xC  
		_T(""),		// 0xA 0xD   
		_T(""),		// 0xA 0xE   
		_T("̑"),		// 0xA 0xF  
  
		_T(""),		// 0xB  0x0  
		_T("Q"),		// 0xB  0x1  
		_T("Љ"),		// 0xB  0x2  
		_T("{eBA"),		// 0xB  0x3  
		_T("b"),		// 0xB  0x4  
		_T("ij"),		// 0xB  0x5  
		_T(""),		// 0xB  0x6  
		_T(""),		// 0xB  0x7   
		_T(""),		// 0xB  0x8   
		_T(""),		// 0xB  0x9   
		_T(""),		// 0xB  0xA   
		_T(""),		// 0xB  0xB   
		_T(""),		// 0xB  0xC   
		_T(""),		// 0xB  0xD   
		_T(""),		// 0xB  0xE   
		_T("̑"),		// 0xB  0xF  

		_T(""),		// 0xC 0x0   
		_T(""),		// 0xC 0x1   
		_T(""),		// 0xC 0x2   
		_T(""),		// 0xC 0x3   
		_T(""),		// 0xC 0x4   
		_T(""),		// 0xC 0x5   
		_T(""),		// 0xC 0x6   
		_T(""),		// 0xC 0x7   
		_T(""),		// 0xC 0x8   
		_T(""),		// 0xC 0x9   
		_T(""),		// 0xC 0xA   
		_T(""),		// 0xC 0xB   
		_T(""),		// 0xC 0xC   
		_T(""),		// 0xC 0xD   
		_T(""),		// 0xC 0xE   
		_T(""),		// 0xC 0xF   

		_T(""),		// 0xD 0x0   
		_T(""),		// 0xD 0x1   
		_T(""),		// 0xD 0x2   
		_T(""),		// 0xD 0x3   
		_T(""),		// 0xD 0x4   
		_T(""),		// 0xD 0x5   
		_T(""),		// 0xD 0x6   
		_T(""),		// 0xD 0x7   
		_T(""),		// 0xD 0x8   
		_T(""),		// 0xD 0x9   
		_T(""),		// 0xD 0xA   
		_T(""),		// 0xD 0xB   
		_T(""),		// 0xD 0xC   
		_T(""),		// 0xD 0xD   
		_T(""),		// 0xD 0xE   
		_T(""),		// 0xD 0xF   

		_T("BS/nfW^pԑgt"),		// 0xE 0x0  
		_T("Lш CSfW^pg"),		// 0xE 0x1  
		_T("qfW^pg"),		// 0xE 0x2  
		_T("T[o[^ԑgt"),		// 0xE 0x3  
		_T("IPpԑgt"),		// 0xE 0x4  
		_T(""),		// 0xE 0x5   
		_T(""),		// 0xE 0x6   
		_T(""),		// 0xE 0x7   
		_T(""),		// 0xE 0x8   
		_T(""),		// 0xE 0x9   
		_T(""),		// 0xE 0xA   
		_T(""),		// 0xE 0xB   
		_T(""),		// 0xE 0xC   
		_T(""),		// 0xE 0xD   
		_T(""),		// 0xE 0xE   
		_T(""),		// 0xE 0xF   

		_T(""),		// 0xF  0x0   
		_T(""),		// 0xF  0x1   
		_T(""),		// 0xF  0x2   
		_T(""),		// 0xF  0x3   
		_T(""),		// 0xF  0x4   
		_T(""),		// 0xF  0x5   
		_T(""),		// 0xF  0x6   
		_T(""),		// 0xF  0x7   
		_T(""),		// 0xF  0x8   
		_T(""),		// 0xF  0x9   
		_T(""),		// 0xF  0xA   
		_T(""),		// 0xF  0xB   
		_T(""),		// 0xF  0xC   
		_T(""),		// 0xF  0xD   
		_T(""),		// 0xF  0xE   
		_T("̑"),		// 0xF  0xF  
	};
	static const TCHAR *c_undefined_str = _T("`");
	static const TCHAR *c_unassign_str = _T("");
	
	_ASSERT( sizeof(c_lvl2_str) / sizeof(c_lvl2_str[0]) == 0x100 );
	if ( genre < 0 )
		return c_unassign_str;
	else
	{
		const TCHAR *pret = c_lvl2_str[genre&0xFF];
		if ( !*pret || !pret )			// ""̏ꍇA`
			return c_undefined_str;
		else
			return pret;
	}
}

static TCHAR *_get_datetime_str(time_t tt)
{
	static TCHAR	sz_tbuf[64];

	_tcsftime( sz_tbuf, 64, _T("%Y/%m/%d %H:%M:%S"), localtime(&tt) );

	return sz_tbuf;
}

static UINT64 _make_key( int network_id, int transport_id, int service_id)
{
	UINT64	key = network_id;
	key <<= 16;
	key |= transport_id;
	key <<= 16;
	key |= service_id;
	return key;
}

// SDTT[rXTB
// ȂƂ
//		SDTɊYڂȂ			ev_psdt̍ŏ̍ڂservices.end()
//		serviceszɍڂȂ	ev_psdt̍Ō̍ڂservices.end()
// ev_psdts̍ڐ0łȂƑO
static bool  _find_sdt_svc(int network_id, int transport_id, int service_id, CSDT::VECT_SERV::iterator &it)
{
	CSDT	key;
	key.id					= transport_id;
	key.original_network_id = network_id;
	key.table_id			= -1;		// network_id,id(transport_id)ŏ̍ڂԂ悤ɂ邽߁BCSDT::CompareTo()̎ˑȂł܂낵Ȃ
	
	vector<CSDT*>::iterator p = lower_bound( ev_psdts.begin(), ev_psdts.end(), &key, _compare_sdt );
	if ( p == ev_psdts.end() || (*p)->id != transport_id || (*p)->original_network_id != network_id )
	{
		return false;
	}
	for ( ; p != ev_psdts.end(); ++p )
	{
		CSDT *psdt = *p;
		if ( psdt->original_network_id != network_id || psdt->id != transport_id )
			break;
		for ( CSDT::VECT_SERV::iterator is = psdt->services.begin(); is != psdt->services.end(); ++is )
		{
			if ( is->service_id == service_id )
			{
				// BꍇASDTHH
				it = is;
				return true;
			}
		}
	}
	return false;
}

static SServiceInfo*	_make_program_info(MAP_SERV	&services, const CEIT *peit, time_t tot_start, time_t tot_end)
{
	SServiceInfo	*psvc;
	{
		UINT64 map_key = _make_key( peit->original_network_id, peit->transport_stream_id, peit->id );
		MAP_SERV::_Pairib pib = services.insert( MAP_SERV::value_type( map_key, SServiceInfo() ) );

		psvc = &pib.first->second;
		if ( pib.second )
		{	// VKo^
			// o
			psvc->network_id		= peit->original_network_id;
			psvc->transport_id	= peit->transport_stream_id;
			psvc->service_id		= peit->id;
			
			// YT[rXSDTAOȂǂZbg
			CSDT::VECT_SERV::iterator is;
			if ( !_find_sdt_svc( psvc->network_id, psvc->transport_id, psvc->service_id, is ) )
			{
				DBG_LOG_ASSERT( _T("\rnetwork_id:%d trans_id:%d svc_id:%dSDT/ServiceȂ\n"), psvc->network_id, psvc->transport_id, psvc->service_id );
			}
			else
			{
				for ( VECT_DESC::iterator iv = is->descriptors.begin(); iv != is->descriptors.end(); ++iv )
				{
					switch ( iv->tag )
					{
					case DSCTAG_SERVICE:
						{
							CServiceDesc desc(*iv);
							psvc->prov_name = desc.service_provider_name;
							psvc->name = desc.service_name;
							psvc->service_type = desc.service_type;
							goto end_serv_find_loop;
						}
					}
				}
end_serv_find_loop:
				;
			}
		}
	}
	for ( vector<CEIT::CEvent>::const_iterator ie = peit->event_tbl.begin(); ie != peit->event_tbl.end(); ie++ )
	{
		bool	b_add_prg = false;
		time_t	t_start, t_end;
		tm		tm_b;

		_convert_time_jst40( ie->start_time, tm_b );
		t_start = mktime( &tm_b );
		_convert_time_bcd( ie->duration, tm_b );
		t_end = t_start + tm_b.tm_hour * 3600 + tm_b.tm_min * 60 + tm_b.tm_sec;

		if ( ev_opt_is_all_out )
			b_add_prg = true;
		else
		{
			// tot_start`tot_end̊Ԃt_startAt_end͂Ă邩
			if ( t_start < tot_start )
				b_add_prg = tot_start <= t_end;
			else
				b_add_prg = t_start <= tot_end;
		}

		if ( b_add_prg )
		{
			SProgramInfo *pprg;
			{
				MAP_PRG::_Pairib pib = psvc->programs.insert( MAP_PRG::value_type( ie->event_id, SProgramInfo() ) );
				pprg = &pib.first->second;
				if ( pib.second )
				{	// VKo^Ao
					pprg->event_id = ie->event_id;
					pprg->start_time = t_start;
					pprg->end_time = t_end;
					pprg->genre = -1;
					pprg->flg = 0;
					pprg->stream_content = -1;
					pprg->component_type = -1;
					pprg->ext_evt_flg = 0;
				}
			}
			const int prg_all_flg = 4;
			// XPW[nƌ/̔ԑgnevent_idd\LB
			// ZbgƒxȂŁAɐݒ肵̓ZbgȂ悤ɂ
			// XQ񂵂ZbgȂ()Ȃ̂ŁACɂȂĂȂ(^_^;
			if ( pprg->flg ^ ((1<<prg_all_flg)-1) )
			{
				for ( VECT_DESC::const_iterator id = ie->descriptors.begin(); id != ie->descriptors.end(); id++ )
				{
					try
					{
						switch ( id->tag )
						{
						case DSCTAG_SHORTEVT:
							if ( !(pprg->flg & (1<<0)) )
							{
								CShortEventDesc	dsc(*id);

								pprg->name_str = dsc.name_str;
								pprg->desc_str = dsc.desc_str;
								if ( dsc.name_str.length() > 0 && dsc.desc_str.length() > 0 )
									pprg->flg |= 1<<0;
							}
							break;
						case DSCTAG_CONTENT:
							if ( !(pprg->flg & (1<<1)) )
							{
								CContentDesc dsc(*id);

								pprg->genre = (dsc.content_nibble_level_1<<4) | dsc.content_nibble_level_2;
								pprg->flg |= 1<<1;
							}
							break;
						case DSCTAG_COMPONENT:
							if ( !(pprg->flg & (1<<2)) )
							{
								CComponentDesc dsc(*id);

								pprg->stream_content = dsc.stream_content;
								pprg->component_type = dsc.component_type;
								pprg->flg |= 1<<2;
							}
							break;
						case DSCTAG_EXTEVT:
							if ( !(pprg->flg & (1<<3)) )
							{
								CExtEventDesc	dsc(*id);
								static VECT_UINT8 *st_p_prev_dat = NULL;		// ږ󔒂̊gLq͂̑O̍ڂ̋LqȂ݂B
																				// staticɂfor[v̊OŐ錾ƂΗǂ悤ȋCB

								for ( CExtEventDesc::VECT_ITEM::iterator ix = dsc.items.begin(); ix != dsc.items.end(); ++ix )
								{
									if ( (*ix).description.length() > 0 || !st_p_prev_dat )
									{
										CNTR_EXTEV::_Pairib pib = pprg->ext_evts.insert( CNTR_EXTEV::value_type((*ix).description, VECT_UINT8()) );
										VECT_UINT8 &data = (*pib.first).second;
										// ڋLq𖖔ɒǉ
										copy( (*ix).text.begin(), (*ix).text.end(), back_inserter(data) );
										st_p_prev_dat = &data;									
									}
									else
									{
										// O̍ڋLq̖ɒǉ
										copy( (*ix).text.begin(), (*ix).text.end(), back_inserter(*st_p_prev_dat) );
									}
								}
								if ( dsc.text.size() > 0 )
								{
									CNTR_EXTEV::_Pairib pib = pprg->ext_evts.insert( CNTR_EXTEV::value_type(_T(""), VECT_UINT8()) );
									VECT_UINT8 &data = (*pib.first).second;

									copy( dsc.text.begin(), dsc.text.end(), back_inserter(data) );
								}
								pprg->ext_evt_flg |= (1<<dsc.descriptor_number);
								// S̊g`CxgLqq獀ڃZbgrbg𗧂ĂB
								// CxgIDŕʓe̊g`CxgLqqA͖(̂ȁH)
								if ( !(pprg->ext_evt_flg ^ ((1<<(dsc.last_descriptor_number+1))-1)) )
								{
									pprg->flg |= 1<<3;
									st_p_prev_dat = NULL;
								}
							}
							break;
						// ̋LqqǉꍇAprg_all_flg𑝂₵āApprg->flgŗĂrbg𑼂ƏdȂ悤ɂ邱
						}
					}
					catch (CDefExcept &d)
					{
						DBG_LOG_ASSERT( _T("\rservice:%d event:%d dscidx:%d %s\n"), 
							psvc->service_id, pprg->event_id, id - ie->descriptors.begin(), d.str_msg );
					}
				}
			}
		}
	}
	return psvc;
}

static bool _compare_prg(const MAP_PRG::const_iterator &it1, const MAP_PRG::const_iterator &it2)
{
	return it1->second.start_time < it2->second.start_time;
}

// ̍\
// lpszFileName			o̓t@C
// time_offset_out		TOTo͎ɃItZbge󂯂H
// offset_beg			JnԃItZbg(b)
// offset_end			IԃItZbg(b)
static int _output_program_info(tofstream &ofs)
{
	MAP_SERV		services;
	// ʏTIME_JST40̔rłƎvA0:00ׂƂȂ肻Ȃ̂ŁAtime_tŎԔr
	time_t		tot_start, tot_end;		

	if		( ev_pats.size() == 0 )
		return ERR_NOPAT;
	else if ( ev_tots.size() < 2 )
		return ERR_NOTOT;	
	else if ( ev_psdts.size() == 0 )
		return ERR_NOSDT;

	tot_start = ev_tots[0].m_time;
	tot_end = ev_tots[1].m_time;

	if ( tot_start + ev_opt_offset_beg > tot_end - ev_opt_offset_end )
	{	// TSbȂꍇAstart/end̒Ԓl
		time_t t_dummy = (tot_start+tot_end)/2;
		tot_start = tot_end = t_dummy;
	}
	else
	{
		tot_start += ev_opt_offset_beg;
		tot_end -= ev_opt_offset_end;
	}

	clock_t clk_st = clock();

	if ( ev_opt_is_all_out )
	{
		for ( vector<CEIT*>::iterator ie = ev_peits.begin(); ie != ev_peits.end(); ++ie )
			_make_program_info( services, *ie, tot_start, tot_end );
	}
	else
	{
		for ( vector<CPAT>::iterator ip = ev_pats.begin(); ip != ev_pats.end(); ip++ )
		{
			for ( VECT_UINT16::iterator ipp = ip->prg_nos.begin(); ipp != ip->prg_nos.end(); ipp++ )
			{
				vector<CEIT*>::iterator pos;
				SServiceInfo *psvc;
				{
					CEIT	key;
					key.transport_stream_id = ip->id;
					key.id					= *ipp;
					key.original_network_id	= 0;			// transport_id,id(service_id)ŏ̍ڂԂ悤ɂ邽߁BCEIT::CompareTo()̎ˑȂł܂낵Ȃ
					pos = lower_bound(ev_peits.begin(), ev_peits.end(), &key, _compare_eit );
					if ( pos == ev_peits.end() || (*pos)->id != key.id )
					{	
						// SDTT[rXEITȂ̂̂ꉞmFBnetwork_id͓KɃZbg
						CSDT::VECT_SERV::iterator p;
						bool flg = false;
						if ( _find_sdt_svc( ev_peits.front()->original_network_id, key.transport_stream_id, key.id, p ) )
						{
							if ( !p->eit_present_following_flag && (!ev_opt_read_eit_sch || !p->eit_schedule_flag) )
								flg = true;
						}
						if ( !flg )
							DBG_LOG_ASSERT( _T("\rtrans_id:%d svc_id:%dSDTȂ̂ŁAEIT݂Ȃ̂ǂʂłȂ\n"), ip->id, *ipp );
						continue;
					}
				}
				do
				{
					psvc = _make_program_info( services, *pos, tot_start, tot_end );
					pos++;
				}	
				while (pos != ev_peits.end()
					&&	(*pos)->id == psvc->service_id 
					&&  (*pos)->transport_stream_id == psvc->transport_id
					&&	(*pos)->original_network_id == psvc->network_id );
			}
		}
		// SProgramInfoȂSServiceInfo폜
		{
			MAP_SERV::iterator p = services.begin();
			while ( p != services.end() )
			{
				if ( p->second.programs.size() == 0 )
					p = services.erase( p );
				else
					p++;
			}
		}
	}
	//DBG_LOG_WARN( _T("make_prg:%.2f\n"), static_cast<double>(clock() - clk_st) / CLOCKS_PER_SEC );
	//----------

	clk_st = clock();
#ifdef _TEST_USE_FS_
	tofstream&	tss = ofs;
#else
	tstrstream tss;
#endif
	//----------
	tss << _T("TOT");
	if ( !ev_opt_outtime_offset )
	{
		tss << _T("\t") << _get_datetime_str(ev_tots[0].m_time);
		tss << _T("\t") << _get_datetime_str(ev_tots[1].m_time);
	}
	else
	{
		tss << _T("\t") << _get_datetime_str(tot_start);
		tss << _T("\t") << _get_datetime_str(tot_end);
	}
	tss << endl;
	if ( ev_opt_is_out_patpmt )
	{
		for ( vector<CPAT>::iterator ip = ev_pats.begin(); ip != ev_pats.end(); ip++ )
		{
			_ASSERT( ip->prg_nos.size() == ip->prg_map_pids.size() );
			for ( size_t i = 0; i < ip->prg_nos.size(); i++ )
			{
				tss << _T("PAT");
				tss << _T("\t") << ip - ev_pats.begin();
				tss << _T("\t") << ip->id;
				tss << _T("\t") << i;
				tss << _T("\t") << ip->prg_nos[i];
				tss << _T("\t") << ip->prg_map_pids[i];
				tss << endl;
			}
		}
		int i = 0;
		for ( vector<CPMT>::iterator im = ev_pmts.begin(); im != ev_pmts.end(); im++ )
		{
			for ( CPMT::VECT_STRM::iterator is = im->stream_tbl.begin(); is != im->stream_tbl.end(); is++ )
			{
				tss << _T("PMT1");
				tss << _T("\t") << i;
				tss << _T("\t") << im->m_self_pid;
				tss << _T("\t") << im->id;
				tss << _T("\t") << is - im->stream_tbl.begin();
				tss << _T("\t") << is->stream_type;
				tss << _T("\t") << is->elementary_pid;
				tss << endl;
			}
			tss << _T("PMT2");
			tss << _T("\t") << i;
			tss << _T("\t") << im->m_self_pid;
			tss << _T("\t") << im->id;
			tss << _T("\t") << im->m_file_pos;
			tss << _T("\t") << im->pcr_pid;
			tss << endl;
			i++;
		}
	}

	for ( MAP_SERV::iterator im = services.begin(); im != services.end(); im++ )
	{
		SServiceInfo &ssi = im->second;
		tss << _T("SVC");
		tss << _T("\t") << ssi.network_id;
		tss << _T("\t") << ssi.transport_id;
		tss << _T("\t") << ssi.service_id;
		switch ( ssi.network_id )
		{
		case 4:		// BSfW^
			tss << _T("\tBS");	break;
		case 1:		// PerfecTV!	
		case 3:		// SKY
		case 6:		// XJp[ e2(CS1)
		case 7:		// XJp[ e2(CS2)
		case 10:	// XJp[ HD
			tss << _T("\tCS");	break;
		default:
			if ( 0x7880 <= ssi.network_id && ssi.network_id <= 0x7FE8 )
				tss << _T("\tnf");
			else
				tss << _T("\t̑");
			break;
		}
		tss << _T("\t") << ssi.name.c_str();
		tss << _T("\t") << ssi.prov_name.c_str();
		tss << _T("\t") << ssi.service_type;
		tss << endl;

		// JnԂŃ\[g
		vector<MAP_PRG::const_iterator>	sort_prgmap;
		for ( MAP_PRG::const_iterator ip = ssi.programs.begin(); ip != ssi.programs.end(); ip++ )
			sort_prgmap.push_back( ip );
		sort( sort_prgmap.begin(), sort_prgmap.end(), _compare_prg );

		//for ( MAP_PRG::iterator ip = ssi.programs.begin(); ip != ssi.programs.end(); ip++ )
		for ( vector<MAP_PRG::const_iterator>::iterator it = sort_prgmap.begin(); it != sort_prgmap.end(); ++it )
		{
			//SProgramInfo &spi = ip->second;
			const SProgramInfo &spi = (*it)->second;

			tss << _T("EVT");
			tss << _T("\t") << ssi.service_id;
			tss << _T("\t") << spi.event_id;
			tss << _T("\t") << _get_datetime_str(spi.start_time);
			tss << _T("\t") << _get_datetime_str(spi.end_time);
			tss << _T("\t");
			tss.write( spi.name_str.c_str(), spi.name_str.length() );
			tss << _T("\t") << spi.genre;
			tss << _T("\t") << _get_genre_lvl1_str(spi.genre);
			tss << _T("\t") << _get_genre_lvl2_str(spi.genre);
			if ( ev_opt_evt_output_type >= 1 )
			{
				if ( spi.stream_content == 1 || spi.stream_content == 5 )
				{
					switch ( (spi.component_type >> 4) & 0xf )
					{
					case 0x0:	tss << _T("\t480i");	break;
					case 0x9:	tss << _T("\t2160p");	break;
					case 0xA:	tss << _T("\t480p");	break;
					case 0xB:	tss << _T("\t1080i");	break;
					case 0xC:	tss << _T("\t720p");	break;
					case 0xD:	tss << _T("\t240p");	break;
					case 0xE:	tss << _T("\t1080p");	break;
					case 0xF:	tss << _T("\t180p");	break;
					default:	tss << _T("\t????");	break;
					}
				}
				else if ( spi.stream_content == -1 )
					tss << _T("\tw");
				else
					tss << _T("\tf");

				tss << _T("\t") << ((spi.stream_content<<8)|spi.component_type);
			}
			if ( ev_opt_evt_output_type >= 2 )
			{
				tss << _T("\t");
				tss.write( spi.desc_str.c_str(), spi.desc_str.length() );
			}
			tss << endl;
			if ( ev_opt_is_out_extevt )
			{
				int i = 0;
				for ( CNTR_EXTEV::const_iterator ie = spi.ext_evts.begin(); ie != spi.ext_evts.end(); ++ie )
				{
					const tstring		&name = (*ie).first;
					const VECT_UINT8	&data = (*ie).second;
					if ( name.length() > 0 || data.size() > 0 )
					{
						tstring		text;
						AribToString( &text, &data[0], data.size() );

						tss << _T("XEVT");
						tss << _T("\t") << ssi.service_id;
						tss << _T("\t") << spi.event_id;
						tss << _T("\t") << i;
						tss << _T("\t") << name.c_str();
						tss << _T("\t") << text.c_str();
						tss << endl;

						i++;
					}
				}
			}
		}
	}
#ifndef _TEST_USE_FS_
	{
		ofs << tss.rdbuf();
	}
#endif
	//DBG_LOG_WARN(_T("write_prg:%.2f\n"), static_cast<double>(clock() - clk_st) / CLOCKS_PER_SEC );

	return 0;
}

static void _dbg_out(tofstream &ofs)
{
#ifndef _TEST_USE_FS_
	tstrstream ou;
#else
	tofstream &ou = ofs;
#endif
	
	ou << _T("<<PAT>>") << endl;
	for ( vector<CPAT>::iterator p = ev_pats.begin(); p != ev_pats.end(); p++ )
	{
		ou << _T("trans_id:") << p->id << _T(" version:") << p->version << _T(" section:") << p->section << _T(" last_section:") << p->last_section << endl;
		for ( size_t i = 0; i < p->prg_nos.size(); i++ )
		{
			ou << _T("  [") << i << _T("] prg_no:") << (int)p->prg_nos[i] << _T(" pmt_pid:") << (int)p->prg_map_pids[i] << endl;
		}
		ou << endl;
	}

	ou << endl << _T("<<PMT>>") << endl;
	for ( vector<CPMT>::iterator p = ev_pmts.begin(); p != ev_pmts.end(); p++ )
	{
		ou << _T("service_id:") << p->id << _T(" pcr_pid:") << p->pcr_pid << _T(" version:") << p->version << endl;
		ou << _T("desc_tag:");
		for ( VECT_DESC::iterator d = p->descriptors.begin(); d != p->descriptors.end(); d++ )
			ou << hex << showbase << d->tag << ",";
		ou << dec << noshowbase << endl;
		int i = 0;
		for ( vector<CPMT::CStream>::iterator s = p->stream_tbl.begin(); s != p->stream_tbl.end(); s++, i++ )
		{
			ou << _T("    [") << i << _T("] stream_type:") << s->stream_type << _T(" elementary_pid:") << s->elementary_pid << endl;
			ou << _T("    desc_tag:");
			for ( VECT_DESC::iterator d = s->descriptors.begin(); d != s->descriptors.end(); d++ )
				ou << hex << showbase << d->tag << ",";
			ou << dec << noshowbase << endl;
		}
	}

	ou << endl << _T("<<SDT>>") << endl;
	for ( vector<CSDT*>::iterator sp = ev_psdts.begin(); sp != ev_psdts.end(); ++sp )
	{
		CSDT *p = *sp;

		ou << _T("trans_id:") << p->id << _T(" network_id:") << p->original_network_id;
		ou << _T(" tbl_id:") << hex << showbase << p->table_id;
		ou << _T(" version:") << dec << noshowbase << p->version << endl;
		int i = 0;
		for ( CSDT::VECT_SERV::iterator pp = p->services.begin(); pp != p->services.end(); ++pp, ++i )
		{
			ou << _T("    [") << i << _T("] service_id:") << pp->service_id << _T(" eit_sch_flg:") << pp->eit_schedule_flag;
			ou << _T(" eit_pres_flg:") << pp->eit_present_following_flag << endl;
			ou << _T("    desc_tag:");
			for ( VECT_DESC::iterator d = pp->descriptors.begin(); d != pp->descriptors.end(); d++ )
				ou << hex << showbase << d->tag << ",";
			ou << dec << noshowbase << endl;
		}
	}

	ou << endl << _T("<<TOT>>") << endl;
	for ( vector<CTOT>::iterator p = ev_tots.begin(); p != ev_tots.end(); p++ )
	{
		TCHAR	szbuf[64];
		tm		t;
		_convert_time_jst40( p->jst_time, t );
		_tcsftime( szbuf, 64, _T("%y/%m/%d %H:%M:%S"), &t );
		ou << _T("time:") << szbuf << endl;
	}

	ou << endl << _T("<<EIT>>") << endl;
	for ( vector<CEIT*>::iterator ep = ev_peits.begin(); ep != ev_peits.end(); ep++ )
	{
		CEIT *p = *ep;

		ou << _T("trans_id:") << p->transport_stream_id << _T(" service_id:") << p->id << _T(" network_id:") << p->original_network_id;
		ou << _T(" tbl_id:") << hex << showbase << p->table_id;
		ou << _T(" version:") << dec << noshowbase << p->version << endl;
		ou << _T("sections:");
		for ( set<UINT8>::const_iterator pp = p->GetProcSections().begin(); pp != p->GetProcSections().end(); pp++ )
		{
			ou << *pp << _T(",");
		}
		ou << endl;
		int i = 0;
		for ( vector<CEIT::CEvent>::iterator e = p->event_tbl.begin(); e != p->event_tbl.end(); e++, i++ )
		{
			tm		t;
			TCHAR	szbuf[64];
			_convert_time_jst40( e->start_time, t );
			_tcsftime( szbuf, 64, _T("%y/%m/%d %H:%M"), &t );
			ou << _T("  [") << i << _T("] evt_id:") << e->event_id << _T(" start_time:") << szbuf;
			_convert_time_bcd( e->duration, t );
			ou << _T(" duration:") << setfill(_T('0')) << setw(2) << t.tm_hour << _T(":") << setw(2) << t.tm_min << _T(":") << setw(2) << t.tm_sec;
			ou << setfill(_T(' ')) << endl;
			ou << _T("    desc_tag:");
			for ( VECT_DESC::iterator d = e->descriptors.begin(); d != e->descriptors.end(); d++ )
				ou << hex << showbase << d->tag << ",";
			ou << dec << noshowbase << endl;
		}
		ou << endl;
	}
#ifndef _TEST_USE_FS_
	ofs << ou.rdbuf();
#endif
}

// fobOOo
// ̊֐͏nˑ㓙ō(^_^;
void dbg_log_out(int rpt_type, TCHAR *filename, int line, TCHAR *lpsz_msg, ... )
{
	TCHAR	szmsg[4096];
	TCHAR	sfname[256], sext[256];
	va_list	va_arg;
	
	_tsplitpath( filename, NULL, NULL, sfname, sext );

	va_start( va_arg, lpsz_msg );
	_vsntprintf( szmsg, 4096, lpsz_msg, va_arg);		// vsnprintf
	va_end( va_arg );
#ifdef _UNICODE
	_RPTW4( (rpt_type==_CRT_ASSERT?_CRT_WARN:rpt_type), _T("%s%s(%d) %s"), sfname, sext, line, szmsg );
#else
	_RPT4( (rpt_type==_CRT_ASSERT?_CRT_WARN:rpt_type), _T("%s%s(%d) %s"), sfname, sext, line, szmsg );
#endif
	if ( ev_ps_dbglog )
	{
		if ( !ev_dbglog_flg )
		{	// ̎sŏ߂Ă̏ꍇAt@CfobOOɋLq
			*ev_ps_dbglog << _T("\r") << ev_opt_input_fname << endl;
			ev_dbglog_flg = true;
		}
		switch ( rpt_type )
		{
		case _CRT_WARN:		*ev_ps_dbglog << _T("<WARN>");	break;
		case _CRT_ERROR:	*ev_ps_dbglog << _T("<ERR >");	break;
		case _CRT_ASSERT:	*ev_ps_dbglog << _T("<ASSR>");	break;
		}
		*ev_ps_dbglog << sfname << sext << _T("(") << line << _T(") ");
		*ev_ps_dbglog << szmsg;
	}
}

// ͂ƕ\
// Ԃl:0		G[Ȃ
static int _parse_option(int argc, _TCHAR* argv[])
{
	// 
	int			ch;
	TCHAR		*p_end;

	while ((ch = getopt(argc, argv, _T("o:r:d:l:sVnB:E:e:Txap"))) != -1)
	{
		switch ( ch )
		{
		case 'o':		// offset read
			ev_opt_offset_read = _tcstol( optarg, &p_end, 0 );
			if ( *p_end == '%' )
				ev_opt_offset_read_is_ratio = true;
			else if ( !p_end || !(*p_end) )
			{
				tcerr << _T("oIvV𐔒lɕϊł܂F") << optarg << endl;
				return ERR_PARAM;
			}
			else if ( ev_opt_offset_read < 0 )
			{
				tcerr << _T("oIvVɃ}CiX̒l͎wł܂F") << optarg << endl;
				return ERR_PARAM;
			}
			break;
		case 'r':		// max read sizew				 
			ev_opt_max_read_size = _tcstol( optarg, &p_end, 0 );
			switch (*p_end)
			{
			case _T('%'):	ev_opt_max_read_type = RS_RATIO;	break;
			case _T('s'):
			case _T('S'):	if(ev_opt_max_read_size) ev_opt_max_read_type = RS_SEC;		break;
			case 0:			
				if ( ev_opt_max_read_size < 0 )
				{
					tcerr << _T("rIvVɃ}CiX̒l͎wł܂F") << optarg << endl;
					return ERR_PARAM;
				}
				break;
			default:
				tcerr << _T("rIvV𐔒lɕϊł܂F") << optarg << endl;
				return ERR_PARAM;
			}
			break;
		case 'd':			// fobO_v
			ev_opt_dbgout_fname = optarg;
			break;
		case 'l':			// fobOO
			ev_opt_dbglog_fname = optarg;
			break;
		case 'V':			// ڍ׏o
			ev_opt_verbose = true;
			break;
		case 'n':
			ev_opt_no_progress = true;
			break;
		case 's':			// XPW[EITǂݍ
			ev_opt_read_eit_sch = true;
			break;
		case 'T':			// TOTo͎ItZbgl̉e󂯂
			ev_opt_outtime_offset = true;
			break;
		case 'B':			// JnItZbgb
			//ev_opt_offset_beg = _ttoi(optarg);
			ev_opt_offset_beg = _tcstol( optarg, &p_end, 0 );
			if ( !p_end || !(*p_end) )
			{
				tcerr << _T("BIvV𐔒lɕϊł܂F") << optarg << endl;
				return ERR_PARAM;
			}
			else if ( ev_opt_offset_beg < 0 )
			{
				tcerr << _T("BIvVɃ}CiX̒l͎wł܂F") << optarg << endl;
				return ERR_PARAM;
			}
			break;
		case 'E':			// IItZbgb
			//ev_opt_offset_end = _ttoi(optarg);
			ev_opt_offset_end = _tcstol( optarg, &p_end, 0 );
			if ( !p_end || !(*p_end) )
			{
				tcerr << _T("EIvV𐔒lɕϊł܂F") << optarg << endl;
				return ERR_PARAM;
			}
			else if ( ev_opt_offset_end < 0 )
			{
				tcerr << _T("BIvVɃ}CiX̒l͎wł܂F") << optarg << endl;
				return ERR_PARAM;
			}
			break;
		case 'e':			// EVTȍ͎o͌`
			ev_opt_evt_output_type = _ttoi(optarg);
			break;
		case 'x':			// gCxgo
			ev_opt_is_out_extevt = true;
			break;
		case 'p':			// PAT/PMTo
			ev_opt_is_out_patpmt = true;
			break;
		case 'a':			// ST[rX/Cxgo
			ev_opt_is_all_out = true;
			break;
		}
	}

	argc -= optind;
	argv += optind;

	if ( argc > 0 )
		ev_opt_input_fname  = argv[0];
	if ( argc > 1 )
		ev_opt_output_fname = argv[1];
	if ( !ev_opt_input_fname || (!ev_opt_output_fname && !ev_opt_dbgout_fname) )
	{
		tcerr << _T("eit_txtout.exe [option] input_file output_file") << endl;
		tcerr << _T("[option]eit_txtout.txtQƉ") << endl;
		return ERR_PARAM;
	}

	if ( ev_opt_verbose )
	{	// ڍו\BWo͂ɏo
		tcout << _T("̓t@C               :") << ev_opt_input_fname << endl;
		tcout << _T("o̓t@C               :") << (ev_opt_output_fname ? ev_opt_output_fname : _T("")) << endl;
		tcout << _T("fobO_v(-d)         :") << (ev_opt_dbgout_fname ? ev_opt_dbgout_fname : _T("Ȃ")) << endl;
		tcout << _T("fobOO(-l)           :") << (ev_opt_dbglog_fname ? ev_opt_dbglog_fname : _T("wȂ")) << endl;
		tcout << _T("i\                 :") << ev_opt_no_progress << endl;
		tcout << _T("ǂݍ݃ItZbg(-o)     :") << ev_opt_offset_read << (ev_opt_offset_read_is_ratio ? _T("%") : _T("*1000*188")) << endl;
		tcout << _T("ǂݍ݃TCY(-r)         :") << ev_opt_max_read_size;
		switch ( ev_opt_max_read_type )
		{
		case RS_SIZE:	tcout << _T("*1000*188 byte") << endl;	break;
		case RS_RATIO:	tcout << _T("%") << endl;	break;
		case RS_SEC:	tcout << _T("sec") << endl;	break;
		}
		tcout << _T("XPW[EITǍ(-s)    :") << ev_opt_read_eit_sch << endl;
		tcout << _T("JnItZbgb(-B)     :") << ev_opt_offset_beg << endl;
		tcout << _T("IItZbgb(-E)     :") << ev_opt_offset_end << endl;
		tcout << _T("EVT`o͌`(-e)          :") << ev_opt_evt_output_type << endl;
		tcout << _T("PATPMTo(-p)         :") << ev_opt_is_out_patpmt << endl;
		tcout << _T("g`Cxgo(-x)   :") << ev_opt_is_out_extevt << endl;
		tcout << _T("ST[rX/Cxgo(-a):") << ev_opt_is_all_out << endl;
	}
	return 0;
}

//#define _MY_FILE_BUFFERING_
int _tmain(int argc, _TCHAR* argv[])
{
#ifdef _MY_FILE_BUFFERING_
	// z_uobt@(H)ƂĈBxIɂ͕ς(ToT)
	const int	c_ringbuf_bitsize = 20;				// 
	const int	c_ringbuf_size = 1 << c_ringbuf_bitsize;
	const int	c_ringbuf_mask = c_ringbuf_size-1;
	UINT8		*buf;								// ݂̃|C^
	int			ring_idx;
	UINT8		*ring_mybuf;						// 
	UINT64		total_rdsize = 0;
	UINT8		tempbuf[TS_PACKET_SIZE];			// Oobt@I[𒴂ꍇɎgp
#else
	UINT8		buf[TS_PACKET_SIZE];				// t@Cobt@
#endif
	UINT64		read_btoffset=0;					// ǍItZbgoCg
	UINT64		read_btsize;						// ǍoCgTCY(oCgP)
	UINT64		count = 0, max_read_count = 0;		// Ǎ񐔁AőǍ(0̎S) (pPbgP)
	tofstream	fs_dbglog;
	FILE		*file;
	int			ret = 0;
	time_t		start_time;
	// IvV

#if defined(_DEBUG) && defined(_MSC_VER)
	// Y`FbN
    _CrtSetDbgFlag(_CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF);
//	_CrtSetBreakAlloc( 48068 );
#endif

	// P[ݒ
	_tsetlocale( LC_ALL, _T("") );
	std::locale loc = std::locale();
	loc = std::locale(loc, STR_STL_LOCALE, std::locale::ctype);	// {B3؂Ȃ
	std::locale::global(loc);

	ret = _parse_option(argc, argv );
	if ( ret )
		return ret;
	// 
	if ( ev_opt_dbglog_fname )
	{
		fs_dbglog.open(ev_opt_dbglog_fname, ios_base::out|ios_base::app);		// ǉ[hŊJ
		if ( !fs_dbglog.is_open() )
			ev_ps_dbglog = &tclog;
		else
		{
			ev_ps_dbglog = &fs_dbglog;
			//fs_dbglog.imbue( loc );
		}
	}
	else if ( ev_opt_verbose )
	{
		ev_ps_dbglog = &tclog;
	}
	if ( ev_ps_dbglog && ev_opt_verbose )
	{
	}

	// "S"̓V[PVANZXɍœKB
	// ƓȂł͑xႤ(20secʁH)
	file = _tfopen( ev_opt_input_fname, _T("rbS") );
	if ( !file )
	{
		tcerr << _T("̓t@CJ܂:") << ev_opt_input_fname << endl;
		return ERR_INPUTFILE;
	}
	// Ō܂ŏĊJ܂Bł͔߂̂łŊJ邩ǂ`FbN
	if ( ev_opt_output_fname )
	{
		tofstream	fs_out;
		fs_out.open( ev_opt_output_fname, ios::out );
		if ( !fs_out )
		{
			tcerr << _T("o̓t@CJ܂:") << ev_opt_output_fname << endl;
			return ERR_OUTPUTFILE;
		}
		fs_out.close();
	}
	// 
	// SNULLɂƂ
	memset( ev_pSectionBuf, 0, sizeof(ev_pSectionBuf) );
	memset( ev_BefSectionFilePos, 0, sizeof(ev_BefSectionFilePos) );

	// t@CTCY(ǍoCgTCY)擾
	{
		INT64				beg_pos, end_pos;
		UINT64				file_btsize;
		fseek( file, 0, SEEK_END);		//t@Cֈړ
		end_pos = _ftelli64(file);
		//fs.clear();
		fseek( file, 0, SEEK_SET);		//t@C擪ֈړ
		beg_pos = _ftelli64(file);

		file_btsize = read_btsize = end_pos - beg_pos;

		if ( ev_opt_offset_read )
		{
			if ( ev_opt_offset_read_is_ratio )
			{
				read_btoffset = file_btsize * ev_opt_offset_read / 100;
				// pPbgŊ؂鐔ɂ
				read_btoffset = read_btoffset / TS_PACKET_SIZE * TS_PACKET_SIZE;
			}
			else
				read_btoffset = ev_opt_offset_read * TS_PACKET_SIZE * 1000;
			if ( ev_opt_verbose )
				tcout << _T("ǍItZbgoCg       :") << read_btoffset << endl;

			INT64	offset = read_btoffset;
			const int c_32bit_offset = 0x70000000;
			_fseeki64( file, offset, SEEK_CUR );
		}

		if ( ev_opt_max_read_size )
		{
			switch ( ev_opt_max_read_type )
			{
			case RS_RATIO:
				max_read_count = ev_opt_max_read_size * file_btsize / 100;
				// pPbgPʂɂ
				max_read_count /= TS_PACKET_SIZE;
				break;
			case RS_SIZE:
				max_read_count = ev_opt_max_read_size * 1000;
				break;
			}
		}
		read_btsize = file_btsize - read_btoffset;
		if ( max_read_count > 0 && read_btsize > max_read_count*TS_PACKET_SIZE )
			read_btsize = max_read_count*TS_PACKET_SIZE;		
		if ( ev_opt_verbose && ev_opt_max_read_type != RS_SEC )
			tcout << _T("ǍoCgTCY           :") << read_btsize << endl;
	}

	_ASSERT( read_btoffset % TS_PACKET_SIZE == 0 );

	start_time = time( &start_time );
#ifdef _MY_FILE_BUFFERING_
	// 
	ring_mybuf = new UINT8[c_ringbuf_size];
	fread( ring_mybuf, 1, c_ringbuf_size, file );
	ring_idx = 0;
	total_rdsize = 0;
#endif
	do
	{
		bool dump_flg = false;
		
#ifdef _MY_FILE_BUFFERING_
		if ( ring_mybuf[ring_idx] != 0x47 )
		{	// {IɂɓĂ邱Ƃ͂Ȃ͂(]G[ƂĂ̂ȁH)
			// 0x47ǂނ܂œǂݐi߂
			do
			{
				total_rdsize++;
				ring_idx++;
				ring_idx &= c_ringbuf_mask;
			}
			while ( total_rdsize < read_btsize && ring_mybuf[ring_idx] != 0x47 );
			if ( total_rdsize < read_btsize )
			{	// 1߂
				total_rdsize--;
				ring_idx--;
				ring_idx &= c_ringbuf_mask;
			}
			else
				break;
		}
#else
		int in_char;
		if ( (in_char = fgetc(file)) != 0x47 )
		{	// {IɂɓĂ邱Ƃ͂Ȃ͂(]G[ƂĂ̂ȁH)
			// 0x47ǂނ܂œǂݐi߂
			while ( !feof(file) && (in_char = fgetc(file)) != 0x47 );
			// 1߂
			if ( !feof(file) )
				ungetc( in_char, file );
			else
				break;
		}
		ungetc( in_char, file );
#endif
		count++;
		ev_cur_filepos = read_btoffset / TS_PACKET_SIZE + count;
		// 
#ifdef _MY_FILE_BUFFERING_
		if ( ring_idx + TS_PACKET_SIZE > c_ringbuf_size )
		{	
			// Oobt@I[𒴂ꍇ͈ꎞobt@ɃRs[Ďgp
			// ʂɖRs[ĂǂAx悤ȋĈ
			UINT8 *pdst = tempbuf;
			UINT8 *psrc = &ring_mybuf[ring_idx];
			int i;
			for ( i = 0; i < c_ringbuf_size -ring_idx; i++ )
				*pdst++ = *psrc++;
			_ASSERT( psrc == &ring_mybuf[c_ringbuf_size] );
			psrc = &ring_mybuf[0];
			for ( ; i < TS_PACKET_SIZE; i++ )
				*pdst++ = *psrc++;
			buf = tempbuf;
		}
		else
			buf = &ring_mybuf[ring_idx];
#else
		fread( (char*)&buf[0], 1, TS_PACKET_SIZE, file );
#endif
		int pid = ((buf[1] & 0x1F) << 8) | buf[2];
		switch ( pid )
		{
		case PID_PAT:
		case PID_EIT_0:
		case PID_EIT_1:
		case PID_EIT_2:
		case PID_TOT:
		case PID_SIT:
		case PID_SDT:
			dump_flg = true;
			break;
		default:
			// PMT
			if ( ev_opt_is_out_patpmt )
			{	
				// PAT/PMTo͎PMTz͎gpȂ̂ŁÂߎwł̂݌
				for ( vector<CPAT>::iterator it = ev_pats.begin(); it != ev_pats.end(); ++it )
				{
					if ( find( it->prg_map_pids.begin(), it->prg_map_pids.end(), pid ) != it->prg_map_pids.end() )
					{
						dump_flg = true;
						break;
					}
				}
			}
			break;
		}
		if ( dump_flg )
		{
			bool no_err = true;
			CPacket packet( buf, false );

			CSectionBuf *p_sec = ev_pSectionBuf[packet.header.pid];
			if	(	packet.header.sync != 0x47										// oCgs
				||	packet.header.trans_error										// rbg肠
				||	packet.header.pid >= 0x0002 && packet.header.pid <= 0x000F		// `PID͈
				||	packet.header.scambling == 0x01									// `XNul
				||	(!packet.header.has_adaptation && !packet.header.has_payload)	// `A_ve[VtB[hl
				)
			{
				no_err = false;
				DBG_LOG_WARN( _T("\rpacket headers pos:%d\n"), ev_cur_filepos );
			}
			else if ( packet.header.has_payload )
			{
				if ( packet.header.payload_start )
				{
					if ( packet.p_start_payload[0] == 0 && !p_sec )
					{
						p_sec = ev_pSectionBuf[packet.header.pid] = new CSectionBuf();
						no_err = p_sec->AddData( packet.header.index, packet.p_start_payload, packet.p_end_payload );
						
					}
					else if ( p_sec )
					{
						no_err = p_sec->AddData( packet.header.index, packet.p_start_payload+1, packet.p_end_payload );
					}
				}
				else if ( p_sec )
					no_err = p_sec->AddData( packet.header.index, packet.p_start_payload, packet.p_end_payload );
				if ( !no_err )
					DBG_LOG_ASSERT( _T("\rZNVobt@ݒŃG[ pos:%d\n"), ev_cur_filepos );
				if ( !p_sec )
				{
					if ( ev_BefSectionFilePos[packet.header.pid] )
					{
						DBG_LOG_ASSERT( _T("\rYZNVf[^ȂBpid:0x%X bef_pos:%d\n"), 
							packet.header.pid, ev_BefSectionFilePos[packet.header.pid] );
					}
				}
			}
			if ( p_sec )
			{
				if ( !no_err )
				{	// ݂̃ZNVf[^͎̂Ă
					delete p_sec;
					p_sec = ev_pSectionBuf[packet.header.pid] = NULL;
				}
				else
				{
					eSECTION_RET ret;
					int				proc_cnt = 0;			// 񐔁BfobOpœɐ[Ӗ
					while ( (ret =  _dump_section_data( packet, p_sec, ev_opt_read_eit_sch )) == SEC_OK_RETRY )
						proc_cnt++;
					if ( ret == SEC_OK_END || p_sec->GetData().size() >= 4196 )
					{
						// Ɍƃe[uʖɍőoCg1024/4196قȂ邪A܂ōlȂ
						if ( ret != SEC_OK_END && p_sec->GetData().size() >= 4196 )
						{
							DBG_LOG_ASSERT( _T("\rZNVf[^TCY4196𒴂Ă܂Bpid:0x%X bef_pos:%d\n"),
								packet.header.pid, ev_BefSectionFilePos[packet.header.pid] );
						}
						// ܂ł̃pPbgŏłꍇAsvȂ̂Ŏ̂Ă
						delete p_sec;
						p_sec = ev_pSectionBuf[packet.header.pid] = NULL;
						ev_BefSectionFilePos[packet.header.pid] = ev_cur_filepos;
					}
				}
			}
		}
		if ( !ev_opt_no_progress && (count & ((1<<12)-1)) == 1 )			// (count % (1<<12)) == 1
		{
			time_t cur, rest;
			UINT64 percent;

			if ( ev_opt_max_read_type == RS_SEC )
			{
				if ( ev_tots.size() < 2 )
					percent = 0;
				else
					percent = (ev_tots[1].m_time - ev_tots[0].m_time) * 10000 / ev_opt_max_read_size;
			}
			else
			{
#ifdef _MY_FILE_BUFFERING_
				percent = total_rdsize * 10000 / read_btsize;					// ̂ߏ2ʂ܂ŋ߂(doubleƂƒxƎv)
#else
				UINT64 pos = _ftelli64( file );;
				_ASSERT( pos >= read_btoffset );
				percent = (pos-read_btoffset) * 10000 / read_btsize;			// ̂ߏ2ʂ܂ŋ߂(doubleƂƒxƎv)
#endif
			}
			tcout << _T("\r") << setw(3) << setfill(_T(' ')) << percent / 100;
			tcout << _T(".") << setw(2) << setfill(_T('0')) << percent % 100 << _T("%");

			cur = time( &cur );
			tcout << _T(" o:") << setw(4) << setfill(_T(' ')) << cur - start_time << _T("s");
			if ( percent )
			{
				rest = (cur - start_time) * (10000 - percent) / percent;
				tcout << _T(" c:") << setw(4) << rest << _T("s");
			}
		}
#ifdef _MY_FILE_BUFFERING_
		{
			int bef_blk_idx = ring_idx >> (c_ringbuf_bitsize-1);		// O:0 㔼:1
			total_rdsize += TS_PACKET_SIZE;
			ring_idx += TS_PACKET_SIZE;
			ring_idx &= c_ringbuf_mask;
			int cur_blk_idx = ring_idx >> (c_ringbuf_bitsize-1);		// O:0 㔼:1
			if ( bef_blk_idx != cur_blk_idx )
			{	// gpȂ̃ubNt@Cǂݍ
				int idx = bef_blk_idx<<(c_ringbuf_bitsize-1);
				fread( &ring_mybuf[idx], 1, 1<<(c_ringbuf_bitsize-1), file );
			}
		}

	}while( total_rdsize < read_btsize
#else
	}while( !feof(file) 
#endif
		&& (!max_read_count || !(ev_opt_max_read_type != RS_SEC && count >= max_read_count))
		&& !(ev_opt_max_read_type == RS_SEC && ev_tots.size() >= 2 && ev_tots[1].m_time - ev_tots[0].m_time >= ev_opt_max_read_size )
	);

	fclose( file );
#ifdef _MY_FILE_BUFFERING_
	delete[] ring_mybuf;
#endif

	// ̍\
	if ( ev_opt_output_fname )
	{
		tofstream	ofs;
		//ofs.imbue( loc );
		ofs.open( ev_opt_output_fname, ios_base::out|ios_base::trunc );
		if ( !ofs )
		{
			tcerr << _T("o̓t@CJ܂:") << ev_opt_output_fname << endl;
			ret = ERR_OUTPUTFILE;
		}
		else
		{
			ret = _output_program_info(ofs);
			//ret = _output_program_info(ev_opt_output_fname, ev_opt_outtime_offset, ev_opt_offset_beg, ev_opt_offset_end, ev_opt_evt_output_type);
		}
	}
	
	if ( ev_opt_dbgout_fname )
	{
		tofstream	fs_dbgout;
		fs_dbgout.open(ev_opt_dbgout_fname, ios_base::out|ios_base::trunc);
		if ( fs_dbgout.is_open() )
		{
			//fs_dbgout.imbue( loc );			// ꂵȂƓ{ꕶo͂Ȃ݂B
			fs_dbgout << _T("filename:") << ev_opt_input_fname << endl;
			_dbg_out(fs_dbgout);
		}
		fs_dbgout.close();
	}

	if ( fs_dbglog.is_open() )
		fs_dbglog.close();

	// I
	for ( int i = 0; i < sizeof(ev_pSectionBuf)/sizeof(ev_pSectionBuf[0]); i++ )
	{
		if ( ev_pSectionBuf[i] )
		{
			delete ev_pSectionBuf[i];
			ev_pSectionBuf[i] = NULL;	// ƂȂNULLŖ߂Ƃ
		}
	}
	for ( vector<CEIT*>::iterator ie = ev_peits.begin(); ie != ev_peits.end(); ++ie )
		delete *ie;
	for ( vector<CSDT*>::iterator is = ev_psdts.begin(); is != ev_psdts.end(); ++is )
		delete *is;
	{
		time_t cur = time( &cur );
		if ( cur - start_time > 10 )
			tcout << endl << _T(" o:") << setw(4) << setfill(_T(' ')) << cur - start_time << _T("s");
	}
	return ret;
}

